<template>
  <div class="md-layout">
    <div class="md-layout-item md-size-100">
      <stats-card header-color="blue">
        <template slot="header">
          <div class="card-icon">
            <i class="fa fa-pencil-alt"></i>
          </div>
        </template>
        <template slot="content">
          <div>
            <vue-select
              v-model="queryString"
              :placeholder="placeholder"
              :options="searchResult"
              :onSearch="getDuplicates"
              label="description"
            >
              <span slot="no-options">Inizi a scrivere qualcosa</span>
              <!--<div class="spinner" v-show="true">-->
                <!--<slot name="spinner">Loading...</slot>-->
              <!--</div>-->
            </vue-select>
          </div>
          <div v-if="queryString">
            Confermando questa corrispondenza, non verrà aperta nessuna segnalazione ma verrà aumentata la priorità di quella confermata
            <div>
              <md-button @click="plusOne" class="md-primary md-just-icon md-round green"><md-icon >check</md-icon></md-button>
              <md-button @click="queryString = null; searchResult = [];" class="md-primary md-just-icon md-round red"><md-icon >cancel</md-icon></md-button>
            </div>
          </div>

        </template>
      </stats-card>
    </div>
    <div class="md-layout-item">
      <stats-card header-color="green">
        <template slot="header">
          <div class="card-icon">
            <i class="fa fa-align-center"></i>
          </div>
        </template>
        <template slot="content">
          <div>
            <form-wizard
              ref="widgetWizard"
              title="Creazione guidata segnalazione"
              subtitle=""
              color="#43a047"
              nextButtonText="avanti"
              backButtonText="indietro"
              finishButtonText="crea!"
              @on-complete="onComplete"
              @on-change="onChange"
            >
              <tab-content
                title="Generalità"
                icon="fa fa-address-book"
                :before-change="() => getChildrenValidation('issueInfoStep')"
              >
                <IssueInfoStep
                  :issue="issue"
                  @on-validate="onStepValidate"
                  ref="issueInfoStep"
                ></IssueInfoStep>
              </tab-content>
              <tab-content
                title="Configurazione"
                icon="fa fa-wrench"
                :before-change="() => getChildrenValidation('issueConfigStep')"
              >
                <IssueConfigStep
                  :issue="issue"
                  @on-validate="onStepValidate"
                  ref="issueConfigStep"
                ></IssueConfigStep>
              </tab-content>
              <tab-content
                title="Riepilogo"
                icon="fa fa-check"
                :before-change="() => getChildrenValidation('issueSummaryStep')"
              >
                <IssueSummaryStep
                  :issue="issue"
                  @on-validate="onStepValidate"
                  ref="issueSummaryStep"
                ></IssueSummaryStep>
              </tab-content>
            </form-wizard>
          </div>
        </template>
      </stats-card>
    </div>
  </div>
</template>

<script>
  import { uploadFile } from '../utils/upload-file';

  import {
    StatsCard,
    IssueInfoStep,
    IssueConfigStep,
    IssueSummaryStep
  } from '@/components'
  import VueSelect from 'vue-select';
  import axios from 'axios';

    export default {
      name: "NewIssue",
      data: function () {
        return {
          token: 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6IjU5ZTkwY2U2MWQyZDUyMWZmYzdjMWZiMiIsImlhdCI6MTUzNjQyMzYzN30.HMVTAV1QpN-zYztt4URpkCv502bdft3bClA_1veXSYo',
          issue: {
            picture: null,
            pictureId: '',
            issueImagePreview: '',
            typedAddress: '',
            coordinates: [],
            userInsertedKeywords: [],
            category: null,
            description: ''
          },
          queryString: null,
          placeholder: 'Che cosa vuoi segnalare?',
          searchResult: []
        }
      },
      computed: {
      },
      methods: {
        plusOne: function () {
          this.queryString = null;
          this.searchResult = [];
          this.$notify({
            title: 'SEGNALAZIONE',
            type: 'success',
            text: 'priorità segnalazione aumentata con successo'
          })
        },
        getLocation: function () {
          if ("geolocation" in navigator) {
            navigator.geolocation.getCurrentPosition((position) => {
              this.issue.coordinates.push(position.coords.longitude);
              this.issue.coordinates.push(position.coords.latitude);
            });
          } else {
            /* la geolocalizzazione NON È disponibile */
          }
        },
        getDuplicates: function (queryString) {
          axios.post('/issues/duplicates?distance=6000&affinity=0.1', {
            category: 'Buca',
            coordinates: this.issue.coordinates,
            description: queryString
          })
            .then(({ data: issues}) => {
              console.log(issues);
              this.searchResult = issues;
            })
        },
        getChildrenValidation: function (ref) {
          return this.$refs[ref].validate();
        },
        onStepValidate: function (isValid, model) {
          if (isValid) {
          }
        },
        onComplete: async function () {
          try {
            const { errMsg, uploadedFile } = await uploadFile(this.issue.picture, this.token);
            const authorId = localStorage.getItem('userId');
            this.issue.pictureId = uploadedFile._id;
            delete this.issue.issueImagePreview;
            delete this.issue.picture;
            const { data: issue } = await axios.post('/issues', {...this.issue, authorId });
            this.$notify({
              title: 'SEGNALAZIONE',
              type: 'success',
              text: 'segnalazione creata con successo'
            });
            this.$router.go(-1);
          }
          catch (e) {
            console.log(e);
          }
        },
        onChange: function (prevIndex, nextIndex) {}
      },
      mounted: function () {
        this.getLocation();
      },
      components: {
        IssueSummaryStep,
        IssueConfigStep,
        IssueInfoStep,
        StatsCard,
        VueSelect
      }
    }
</script>

<style scoped>
  .green {
    background-color: green !important;
  }
  .green:hover {
    background-color: lawngreen !important;
  }
  .red {
    background-color: red !important;
  }
  .red:hover {
    background-color: indianred !important;
  }
  .md-card-content {
    text-align: center !important;
  }
</style>
